/* Definitions for bytecode compiler (currently not used).
   Copyright (C) 1992-1997 Jean Goubault-Larrecq and Bull S.A.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* storage classes: */
#define V_EXPRPTR 0
#define V_BOOL 1
#define V_INT 2
#define V_STRING 3
#define V_REAL 4
#define V_CODE 5
#define V_MAPGET 6
#define V_MAPSWEEP 7
#define V_VOID 8
#define V_COUNT 9

/* Variable names are varrefs (number,storage). (rank=number, level=storage). */

typedef struct varNames {
  MapPtr names; /* map from variables to names, or NIL if variable is not used. */
  INT maxn[V_COUNT];
  Boolean has_calls; /* true if this function calls other functions. */
  Boolean has_jumps; /* true if this function does setjmp(). */
  MapPtr consts; /* map from useful constant statements to their values */
  MapPtr bconsts; /* map from boxed constant statements to
		     index in constant table */
  MapPtr uconsts; /* map from unboxed constant statements to
		     Kvarref(offset,storageClass) */
  INT maxbconst,maxuconst;
  MapPtr zapx; /* map from stmts to sets of ExprPtr vars to zap after executing the stmt. */
  MapPtr zapm; /* map from stmts to sets of MapGet vars to zap after executing the stmt. */
} varNames;

#define VN(vn) ((varNames *)EXTDATA(vn))

typedef struct varFreeList {
  MapPtr pendinguses; /* map from variables to mutable counts of their uses. */
  MapPtr free[V_COUNT]; /* set of free names for each storage class */
  INT n[V_COUNT];
} varFreeList;

#define VF(vf) ((varFreeList *)EXTDATA(vf))

#define BC_BUFSIZE 256

typedef struct bcBuffer {
  struct bcBuffer *next;
  INT n;
  OPCODE instr[BC_BUFSIZE];
} bcBuffer;

typedef struct bcFile {
  bcBuffer *buf;
  bcBuffer *current;
} bcFile;

#define DUMMY_OFFSET 0
