/* Definitions for compiler to C (first version, obsolete).
   Copyright (C) 1992-1997 Jean Goubault-Larrecq and Bull S.A.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifdef COMPILER

#define TAB 8
#define INDENT 2

EXTERN MapPtr primCnames;

IMPORT void valPrintNoType P((IN CONST ExprPtr val,
			      IN CONST void (*doprint)(IN CONST CHAR *text,
						       IN COUNTER len,
						       INOUT char *printdata),
			      char *printdata,
			      IN COUNTER pri));

typedef struct codeEmitter {
  void (*doprint) P((IN CONST CHAR *text,IN COUNTER len,INOUT char *printdata));
  char *printdata;
  SymPtr baseSym;
} codeEmitter;

struct emit_state {
  ExprPtr publics; /* (mutable) map from expressions to ML names */
  ExprPtr privates; /* (mutable) map from expressions to ML names */
	/* if <n> is a ML name, the associated C name is Q<base>_<n>,
	where <base> is the base symbol */
  COUNTER suffixCnt;
};

struct emit_in {
  codeEmitter *emitter;
  struct emit_state *state;
  COUNTER res_cnt; /* number of the result variable */
  COUNTER lmargin;
  ExprPtr env;
};

struct emit_out {
  ExprPtr instr_list; /* list of instructions to emit */
  MapPtr forwards; /* map from ML names of auxiliary functions to a descriptor */
};

#endif
