
(* test functions in lip.c: *)

ok "Int" (Int 3=Int 3 andalso Int 3<>Int 4 andalso
	  Int ~3=Int ~3 andalso Int ~3<>Int ~1 andalso
	  Int ~1<>Int 3);

ok "zint" (zint (Int 3)=3 andalso zint (Int 0)=0 andalso
	   zint (Int ~2) = ~2 andalso
	   ((zint (zadd (Int max_int, Int max_int)); true)
		handle _ => false));

ok "znum" (znum (Int 3)=3.0 andalso znum (Int 0)=0.0 andalso
	   znum (Int ~2) = ~2.0 andalso
	   ((znum (zadd (Int max_int, Int max_int)); true)
		handle _ => false));

ok "zsbastoz" (zsbastoz (10, [1, 2, 3])=Int 123 andalso
	       zsbastoz (10, nil)=Int 0);

ok "zbastoz" (zbastoz (Int 10, [Int 1, Int 2, Int 3])=Int 123 andalso
	      zbastoz (Int 10, nil)=Int 0 andalso
	      zbastoz (Int 10, [Int 1, Int 2, Int 3, Int 4, Int 5, Int 6,
				 Int 1, Int 2, Int 3, Int 4, Int 5, Int 6,
				 Int 1, Int 2, Int 3, Int 4, Int 5, Int 6,
				 Int 1, Int 2, Int 3, Int 4, Int 5, Int 6])=
	      zsbastoz (10, [1, 2, 3, 4, 5, 6,
			      1, 2, 3, 4, 5, 6,
			      1, 2, 3, 4, 5, 6,
			      1, 2, 3, 4, 5, 6]));

ok "zstobas" (zstobas (10, Int 123)=[1, 2, 3] andalso
	      zstobas (10, Int 0)=nil andalso
	      zstobas (10, Int ~123)=[1, 2, 3] andalso
	      let val l = [1, 8, 7, 2, 3, 5, 9, 1, 3, 4, 1, 7, 7, 2, 4, 3]
	      in
		  zstobas (10, zsbastoz (10, l)) = l
	      end);

ok "zstosymbas" (zstosymbas (10, Int 123)=[1, 2, 3] andalso
		 zstosymbas (10, Int 0)=nil andalso
		 zstosymbas (10, Int ~123)=[1, 2, 3] andalso
		 let val l = [1, 8, 7, 2, 3, 5, 9, 1, 3, 4, 1, 7, 7, 2, 4, 3]
		     val i = zsbastoz (10, l)
		     val l' = [2,~1,~3,2,4,~4,~1,1,3,4,2,~2,~3,2,4,3]
		 in
		     zstosymbas (10, i) = l' andalso
		     zsbastoz (10, l') = i
		 end);

ok "ztobas" (ztobas (Int 10, Int 123)=[Int 1, Int 2, Int 3] andalso
	     ztobas (Int 10, Int 0)=nil andalso
	     ztobas (Int 10, Int ~123)=[Int 1, Int 2, Int 3] andalso
	     let val l = [Int 1, Int 8, Int 7, Int 2, Int 3, Int 5, Int 9,
			   Int 1, Int 3, Int 4, Int 1, Int 7, Int 7, Int 2,
			   Int 4, Int 3]
	     in
		 ztobas (Int 10, zbastoz (Int 10, l)) = l
	     end);

ok "ztosymbas" (ztosymbas (Int 10, Int 123)=[Int 1, Int 2, Int 3] andalso
		ztosymbas (Int 10, Int 0)=nil andalso
		ztosymbas (Int 10, Int ~123)=[Int 1, Int 2, Int 3] andalso
		let val l = [Int 1, Int 8, Int 7, Int 2, Int 3, Int 5, Int 9,
			      Int 1, Int 3, Int 4, Int 1, Int 7, Int 7, Int 2,
			      Int 4, Int 3]
		    val i = zbastoz (Int 10, l)
		    val l' = [Int 2,Int ~1,Int ~3,Int 2,Int 4,Int ~4,Int ~1,
			       Int 1,Int 3,Int 4,Int 2,Int ~2,Int ~3,Int 2,
			       Int 4,Int 3]
		 in
		     ztosymbas (Int 10, i) = l' andalso
		     zbastoz (Int 10, l') = i
		 end);
ok "zcompare" (zcompare (Int 10, Int 342) = ~1 andalso
	       zcompare (Int 0, Int 342) = ~1 andalso
	       zcompare (Int 342, Int ~10) = 1 andalso
	       zcompare (Int ~2, Int ~2) = 0);

ok "zneg" (zneg (Int 10) = Int ~10 andalso
	   zneg (Int 0) = Int 0 andalso
	   zneg (Int ~10) = Int 10);

ok "zsadd" (zsadd (Int 342, ~10) = Int 332 andalso
	    zsadd (Int 342, ~678) = Int (342-678) andalso
	    zcompare (zsadd (Int max_int, max_int), Int 0) = 1);

ok "zadd" (zadd (Int 342, Int ~10) = Int 332 andalso
	   zadd (Int 342, Int ~678) = Int (342-678) andalso
	   zcompare (zadd (Int max_int, Int max_int), Int 0) = 1);

ok "zsub" (zsub (Int 342, Int 10) = Int 332 andalso
	   zsub (Int 342, Int 678) = Int (342-678) andalso
	   zcompare (zsub (Int max_int, Int min_int), Int 0) = 1);

ok "zsmul" (zsmul (Int 342, ~212) = Int (342 * ~212) andalso
	    zsmul (Int 0, 343) = Int 0 andalso
	    zsmul (Int 1, max_int) = Int max_int andalso
	    zcompare (zsmul (Int max_int, max_int), Int 0) = 1);

ok "zmul" (zmul (Int 342, Int ~212) = Int (342 * ~212) andalso
	   zmul (Int 0, Int 343) = Int 0 andalso
	   zmul (Int 1, Int max_int) = Int max_int andalso
	   zcompare (zmul (Int max_int, Int max_int), Int 0) = 1);

ok "zsqr" (zsqr (Int 342) = Int (342 * 342) andalso
	   zsqr (Int max_int) = zmul (Int max_int, Int max_int) andalso
	   zsqr (Int max_int) = zsmul (Int max_int, max_int));

ok "zsdivmod" (zsdivmod (Int 342, 10) = (Int 34, 2) andalso
	       zsdivmod (Int ~342, 10) = (Int ~35, 8) andalso
	       zsdivmod (Int 342, ~10) = (Int ~35, ~8) andalso
	       zsdivmod (Int ~342, ~10) = (Int 34, ~2) andalso
	       (zsdivmod (Int ~342, 0) = (Int 1, 1) handle Lip n => n=1) andalso
	       zsdivmod (zsadd (zsqr (Int max_int), ~1), max_int)
	       = (Int (max_int-1), max_int-1));

ok "zsmod" (zsmod (Int 342, 10) = 2 andalso
	    zsmod (Int ~342, 10) = 8 andalso
	    zsmod (Int 342, ~10) = ~8 andalso
	    zsmod (Int ~342, ~10) = ~2 andalso
	    (zsmod (Int ~342, 0) = 1 handle Lip n => n=1) andalso
	    zsmod (zsadd (zsqr (Int max_int), ~1), max_int) = max_int-1);

ok "zdivmod" (zdivmod (Int 342, Int 10) = (Int 34, Int 2) andalso
	      zdivmod (Int ~342, Int 10) = (Int ~35, Int 8) andalso
	      zdivmod (Int 342, Int ~10) = (Int ~35, Int ~8) andalso
	      zdivmod (Int ~342, Int ~10) = (Int 34, Int ~2) andalso
	      (zdivmod (Int ~342, Int 0) = (Int 1, Int 1) handle Lip n => n=1) andalso
	      zdivmod (zsadd (zsqr (Int max_int), ~1), Int max_int)
	      = (Int (max_int-1), Int (max_int-1)));

ok "zmod" (zmod (Int 342, Int 10) = Int 2 andalso
	   zmod (Int ~342, Int 10) = Int 8 andalso
	   zmod (Int 342, Int ~10) = Int ~8 andalso
	   zmod (Int ~342, Int ~10) = Int ~2 andalso
	   (zmod (Int ~342, Int 0) = Int 1 handle Lip n => n=1) andalso
	   zmod (zsadd (zsqr (Int max_int), ~1), Int max_int) = Int (max_int-1));

ok "zmadd" (zmadd (Int 342, Int 688, Int 702) = Int 328 andalso
	    (zmadd (Int 342, Int 688, Int 0) = Int 0 handle Lip n => n=2));

ok "zmsub" (zmsub (Int 342, Int 688, Int 702) = Int 356 andalso
	    (zmsub (Int 342, Int 688, Int 0) = Int 0 handle Lip n => n=2));

ok "zmmul" (zmmul (Int 123, Int 342, Int 377) = Int 219 andalso
	    (zmmul (Int 123, Int 342, Int 0) = Int 0 handle Lip n => n=2));

ok "zsmmul" (zsmmul (Int 123, 342, Int 377) = Int 219 andalso
	     (zsmmul (Int 123, 342, Int 0) = Int 0 handle Lip n => n=2));

ok "zmsmul" (zmsmul (123, 342, 377) = 219 andalso
	     (zmsmul (123, 342, 0) = 0 handle Lip n => n=2));

ok "zmsqr" (zmsqr (Int 342, Int 377) = Int 94 andalso
	    (zmsqr (Int 342, Int 0) = Int 0 handle Lip n => n=2));

ok "zmdiv" (zsmmul (zmdiv (Int 342, Int 28, Int 377), 28, Int 377) = Int 342 andalso
	    let val f = zmdiv (Int 342, Int 13, Int 377)
	    in
		zmod (Int 377, f) = Int 0
	    end andalso
	    (zmdiv (Int 342, Int 0, Int 377) = Int 1 handle Lip n => n=1) andalso
	    (zmdiv (Int 342, Int 28, Int 0) = Int 1 handle Lip n => n=2));

ok "zminv" (zsmmul (zminv (Int 28, Int 377), 28, Int 377) = Int 1 andalso
	    let val f = zminv (Int 13, Int 377)
	    in
		zmod (Int 377, f) = Int 0
	    end andalso
	    (zminv (Int 0, Int 377) = Int 1 handle Lip n => n=1) andalso
	    (zminv (Int 28, Int 0) = Int 1 handle Lip n => n=2));

ok "zmontstart" (((zmontstart (Int 377); true) handle _ => false) andalso
		     ((zmontstart (Int 10); false) handle Lip n => n=3) andalso
		     ((zmontstart (Int 1); false) handle Lip n => n=3) andalso
		     ((zmontstart (Int 32); false) handle Lip n => n=3));

(* Now the Montgomery modulus should have been initialized to 377. *)

ok "ztomont" (zmonttoz (ztomont (Int 3)) = Int 3 andalso
	      zmonttoz (ztomont (Int 3247)) = Int (3247 mod 377) andalso
	      zmonttoz (ztomont (Int 0)) = Int 0);

ok "zmontadd" (zmontadd (ztomont (Int 3247), ztomont (Int ~324))
	       = ztomont (Int (2923 mod 377)) andalso
	       zmontadd (ztomont (Int 342), ztomont (Int 688)) = ztomont (Int 1030));

ok "zmontsub" (zmontsub (ztomont (Int 3247), ztomont (Int 324))
	       = ztomont (Int (2923 mod 377)));

ok "zsmontmul" (zsmontmul (ztomont (Int 3247), 7) = ztomont (Int (3247*7 mod 377)));

ok "zmontmul" (zmontmul (ztomont (Int 3247), ztomont (Int 7))
	       = ztomont (Int (3247*7 mod 377)));

ok "zmontsqr" (zmontsqr (ztomont (Int 3247)) = ztomont (Int (3247*3247 mod 377)));

ok "zmontdiv" (zmontdiv (ztomont (Int 3247), ztomont (Int 7)) = 
	       ztomont (zmdiv (Int 3247, Int 7, Int 377)) andalso
	       zmontmul (zmontdiv (ztomont (Int 342), ztomont (Int 28)),
			 ztomont (Int 28)) = ztomont (Int 342) andalso
	       let val f = zmontdiv (ztomont (Int 342), ztomont (Int 13))
	       in
		   zmod (Int 377, f) = Int 0
	       end andalso
	       (zmontdiv (ztomont (Int 342), ztomont (Int 0)) = ztomont (Int 1)
		handle Lip n => n=1));

ok "zmontinv" (zmontinv (ztomont (Int 7)) = 
	       ztomont (zminv (Int 7, Int 377)) andalso
	       zmontmul (zmontinv (ztomont (Int 28)),
			 ztomont (Int 28)) = ztomont (Int 1) andalso
	       let val f = zmontinv (ztomont (Int 13))
	       in
		   zmod (Int 377, f) = Int 0
	       end andalso
	       (zmontinv (ztomont (Int 0)) = ztomont (Int 1)
		handle Lip n => n=1));

ok "zbezout" (zbezout (Int 3, Int 7) = ((Int ~2, Int 1), Int 1) andalso
	      zbezout (Int 2, Int ~2) = ((Int 1, Int 0), Int 2) andalso
	      let val x = Int ~3
	      in
		  zbezout (x, x) = ((Int ~1, Int 0), Int 3) andalso
		  x = Int ~3
	      end andalso
	      (zbezout (Int 0, Int 0) = ((Int 0, Int 0), Int 0) handle Lip n => n=7));

ok "zchirem" (zchirem (Int 11, Int 3, Int 23, Int 7) = Int 168 andalso
	      (zchirem (Int 11, Int 3, Int 11, Int 3) = Int 3 handle _ => false) andalso
	      (zchirem (Int 11, Int 3, Int 11, Int 4) = Int 3 handle Lip n => n=9) andalso
	      (zchirem (Int 24, Int 3, Int 12, Int 3) = Int 4 handle Lip n => n=5) andalso
	      (zchirem (Int 0, Int 3, Int 45, Int 1) = Int 0 handle Lip n => n=6));

zmontstart (Int 37);

ok "zmontexp" (zmontexp (ztomont (Int 34), Int 37) = ztomont (Int 34) andalso
	       zmontexp (ztomont (Int 34), Int 0) = ztomont (Int 1) andalso
	       (zmontexp (ztomont (Int 37), Int ~1) = ztomont (Int 0)
		handle Lip n => n=10));

ok "zsmexp" (zsmexp (Int 34, 37, Int 37) = Int 34 andalso
	     zsmexp (Int 34, 0, Int 37) = Int 1 andalso
	     (zsmexp (Int 37, ~1, Int 37) = Int 0 handle Lip n => n=10));

ok "zmexp" (zmexp (Int 34, Int 37, Int 37) = Int 34 andalso
	    zmexp (Int 34, Int 0, Int 37) = Int 1 andalso
	    (zmexp (Int 37, Int ~1, Int 37) = Int 0 handle Lip n => n=10));

ok "zmontexpm" (zmontexpm (ztomont (Int 34), Int 37) = ztomont (Int 34) andalso
	       zmontexpm (ztomont (Int 34), Int 0) = ztomont (Int 1) andalso
	       (zmontexpm (ztomont (Int 37), Int ~1) = ztomont (Int 0)
		handle Lip n => n=10));

ok "zmexpm" (zmexpm (Int 34, Int 37, Int 37) = Int 34 andalso
	     zmexpm (Int 34, Int 0, Int 37) = Int 1 andalso
	     (zmexpm (Int 37, Int ~1, Int 37) = Int 0 handle Lip n => n=10));

ok "zsexp" (zsmod (zsexp (Int 34, 37), 37) = 34 andalso
	    zsexp (Int 34, 0) = Int 1 andalso
	    (zsexp (Int 34, ~2) = Int 0 handle Lip n => n=10));

ok "zexp" (zsmod (zexp (Int 34, Int 37), 37) = 34 andalso
	   zexp (Int 34, Int 0) = Int 1 andalso
	   (zexp (Int 34, Int ~2) = Int 0 handle Lip n => n=10));

ok "zmsexp" (zmsexp (34, 37, 37) = 34 andalso
	     zmsexp (34, 0, 37) = 1 andalso
	     (zmsexp (34, 2, 0) = 0 handle Lip n => n=2));

ok "zmexp2" (zmexp2 (Int 34, Int 270, Int 576, Int 216, Int 333) =
	     zmmul (zmexp (Int 34, Int 270, Int 333),
		    zmexp (Int 576, Int 216, Int 333),
		    Int 333) andalso
	     (zmexp2 (Int 34, Int 7, Int 576, Int ~2, Int 333) = Int 0
	      handle Lip n => n=10));

zmontstart (Int 333);

ok "zmontexp2" (zmontexp2 (Int 34, Int 270, Int 576, Int 216) =
		zmontmul (zmontexp (Int 34, Int 270),
			  zmontexp (Int 576, Int 216)) andalso
		(zmontexp2 (Int 34, Int 7, Int 576, Int ~2) = Int 0
		 handle Lip n => n=10));

ok "zlsl1" (zlsl1 (Int 34) = Int 68 andalso
	    zlsl1 (Int ~34) = Int ~68 andalso
	    zlsl1 (Int max_int) = zsmul (Int max_int, 2));

ok "zasr1" (zasr1 (Int 34) = Int 17 andalso
	    zasr1 (Int 37) = Int 18 andalso
	    zasr1 (Int ~37) = Int ~18);

ok "zodd" (not (zodd (Int 34)) andalso zodd (Int 37) andalso zodd (Int ~37));

ok "zasl" (zasl (Int 34, 3) = Int 272 andalso
	   zasl (Int ~34, ~2) = Int ~8);

ok "zasr" (zasr (Int 34, 3) = Int 4 andalso
	   zasr (Int ~34, 2) = Int ~8);

ok "zmakeodd" (zmakeodd (Int 34) = (1, Int 17) andalso
	       zmakeodd (Int ~37) = (0, Int ~37) andalso
	       zmakeodd (Int 264) = (3, Int 33) andalso
	       (zmakeodd (Int 0) = (1, Int 1) handle Lip n => n=7));

ok "sqrt" (sqrt 32 = 5 andalso (sqrt ~1 = 1 handle Lip n => n=11));

ok "zsqrt" (zsqrt (Int 32) = (Int 5, Int 7) andalso
	    (zsqrt (Int ~1) = (Int 0, Int 0) handle Lip n => n=11));

ok "zroot" (zroot (Int 32, 5) = Int 2);

ok "zsweight" (zsweight 0xfe564ed4 = 19);

ok "zweight" (all
		zweight (Intofset s) = card s
	      | s in set {{}, {1, 2, 3},
			    {3, 40, 90, 120, 254},
			      {101, 102, 104}}
	      end);

ok "Intofset" (all
		 setofInt (Intofset s) = s
	       | s in set {{30,27,25,20,29}}
	       end);

datatype sset = S_POS of int set
  | S_NEG of int set;

fun ssetofInt n = if zsign n<0
		      then S_NEG (setofInt (znot n))
		  else S_POS (setofInt n);

fun sand (S_POS s1, S_POS s2) = S_POS (s1 & s2)
  | sand (S_POS s1, S_NEG s2) = S_POS (s1 \ s2)
  | sand (S_NEG s1, S_POS s2) = S_POS (s2 \ s1)
  | sand (S_NEG s1, S_NEG s2) = S_NEG (s1 U s2);

ok "zand" (all
	     ssetofInt (zand (s, t)) = sand (ssetofInt s, ssetofInt t)
	   | s in list [Int 2134, Int ~76456, Int 557, Int ~557] and
	     t in list [Int 7, Int 65534, Int 3228, Int ~3328, Int ~7]
	   end);

fun sor (S_POS s1, S_POS s2) = S_POS (s1 U s2)
  | sor (S_POS s1, S_NEG s2) = S_NEG (s2 \ s1)
  | sor (S_NEG s1, S_POS s2) = S_NEG (s1 \ s2)
  | sor (S_NEG s1, S_NEG s2) = S_NEG (s1 & s2);

ok "zor" (all
	    ssetofInt (zor (s, t)) = sor (ssetofInt s, ssetofInt t)
	  | s in list [Int 2134, Int ~76456, Int 557, Int ~557] and
	    t in list [Int 7, Int 65534, Int 3228, Int ~3328, Int ~7]
	  end);

fun sxor (S_POS s1, S_POS s2) = S_POS (s1 delta s2)
  | sxor (S_POS s1, S_NEG s2) = S_NEG (s1 delta s2)
  | sxor (S_NEG s1, S_POS s2) = S_NEG (s1 delta s2)
  | sxor (S_NEG s1, S_NEG s2) = S_POS (s1 delta s2);

ok "zxor" (all
	    ssetofInt (zxor (s, t)) = sxor (ssetofInt s, ssetofInt t)
	  | s in list [Int 2134, Int ~76456, Int 557, Int ~557] and
	    t in list [Int 7, Int 65534, Int 3228, Int ~3328, Int ~7]
	  end);

ok "zbit" (all
	     zbit (s, i) = (zand (s, Intofset {i}) <> Int 0)
	   | s in list [Int 2134, Int ~76456, Int 557, Int ~557] and
	     i in list [~1, 3, 4, 0, 32]
	   end);

ok "zaddbit" (all
		zaddbit (s, i) = zor (s, Intofset {i})
	      | s in list [Int 2134, Int ~76456, Int 557, Int ~557] and
		i in list [~1, 3, 4, 0, 32]
	      end);

ok "zrembit" (all
		zrembit (s, i) = zand (s, znot (Intofset {i}))
	      | s in list [Int 2134, Int ~76456, Int 557, Int ~557] and
		i in list [~1, 3, 4, 0, 32]
	      end);

ok "zsreverse" (zsreverse (0xfacedb87, 16)=0xe1db andalso
		zsreverse (0xfacedb87, 7)=0x70);

ok "zreverse" (all
		 zreverse (s, i) =
		 (if i<=0
		      then Int 0
		  else Intofset ({i-1-j
				 | j in set
				   setofInt (zand (s,
						   zsbastoz (0x10000,
							     [0xffff,
							       0xffff,
							       0xffff,
							       0xffff])))
				     such that j<i}))
	       | s in list [Int 2134, Int ~76456, Int 557, Int ~557, Int ~1] and
		 i in list [~1, 3, 4, 0, 32]
	       end);

ok "zsjacobi" (let val nextprime = primes 1000000
		   val limit = ref 100
	       in
		   nextprime (); (* get rid of 2. *)
		   all
		     let val p = nextprime ()
			 val a = rand ()
		     in
			 dec limit;
			 if a mod p=0
			     then zsjacobi (a, p)=0
			 else let val legendre = zmexp (Int a, Int ((p-1) div 2), Int p)
			      in
				  zsjacobi (a, p) = (if legendre=Int 1
							 then 1
						     else ~1)
			      end
		     end
		   |while !limit<>0
		   end
	       end);

ok "zjacobi" (all
		zjacobi (Int a, Int p) = zsjacobi (a, p)
	      | a in set {~17, ~1, 0, 1, 2, 3, 4, 7, 8, 10, 39, 137} and
		p in set {1, 3, 7, 9, 15, 17}
	      end);

