/* Generate labels for bc.c and bc2.c.
   Copyright (C) 1995-2000 Jean Goubault-Larrecq and Bull S.A.
   Copyright (C) 2000-2005,2021 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include "eval.h"
#include "bc.h"

int main()
{
  FILE *f;
  int i;
  char comma;

  f = fopen("hastag.c","w");
  if (f==NULL)
    {
      fprintf(stderr,"Could not open file 'hastag.c' for writing. Stop.\n");
      fflush(stderr);
      exit(2);
    }
  for (i=0; i<E_UNUSED; i++)
    {
      fprintf(f,"  CASE(%d):",BC_HASTAG+i);
      fprintf(f," if (top[-1]->kind!=(CHAR)%d) goto _goto; pc += 2; NEXT;\n",i);
    }
  fclose(f);

  f = fopen("labs.c","w");
  if (f==NULL)
    {
      fprintf(stderr,"Could not open file 'labs.c' for writing. Stop.\n");
      fflush(stderr);
      exit(2);
    }
  comma = ' ';
  for (i=0; i<BC_HASTAG+E_UNUSED; i++)
    {
      fprintf(f," %c&&CASE(%d)\n",comma,i);
      comma = ',';
    }
  fclose(f);
  exit(0);
}
