# template file contents (makefile.tpl), as included in makefile by makemake:
#  Makefile for HimML.
#  Copyright (C) 1992-2000 Jean Goubault-Larrecq and Bull S.A.
#  Copyright (C) 2000-2005 Jean Goubault-Larrecq
#  and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.
#
#  This file is part of HimML.
#
#  HimML is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2, or (at your option)
#  any later version.
#
#  HimML is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with HimML; see the file COPYING.  If not, write to
#  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

STACK =
PORTABLE = portable.h config.h system.h file.h
EVAL = eval.h $(PORTABLE) refcount.h
EXPR = expr.h
ABSSYN = abssyn.h
COMPILE = compile.h
CONS = cons.h
SPECIAL = special.h
TYPE = type.h
MEM = mem.h
APPLMEM = applmem.h
INPUT = input.h
EXECINIT = execinit.h
ACTIONS = actions.h
PRINT = print.h himml.tab.h
TIMING = timing.h
DEBUGGER = debug.h $(TIMING)
TRANSFER = transfer.h $(DEBUGGER)
GRAM = gram.h himml.tab.h $(TRANSFER)
MESSAGE = messages
#UFIND = ufind.h
BYTECODE = bc.h $(TRANSFER)
BCAUX = $(BYTECODE) bcaux.h
REGEXP = regmagic.h regexp.h
BCI = rbci.h
LIP = lip.h lipact.h

OBJS =  ml.o arith.o exec.o lists.o map.o mapinit.o compile.o compaux.o compinit.o \
	cons.o consinit.o errors.o evalinit.o execinit.o hlexinit.o hyaccinit.o \
	lipinit.o print.o symbols.o \
	expr.o gc.o gramaux.o init.o malloc.o mem.o mathutil.o stack.o modules.o \
	type.o typeaux.o typeinit.o himml.tab.o himml.yy.o refcount.o debug.o \
	profile.o dbginit.o random.o file.o inline.o lip.o table.o \
	dir.o transfer.o bc.o bcaux.o bciaux.o bci0.o bci.o bcinit.o regexp.o hlex.o hyacc.o OTHEROBJS
RUNOBJS = mlrun.o himmlx.a
HIMMLXOBJS = arith.o exec.o lists.o map.o mapinit.o \
	compile2.o compaux2.o compinit.o cons.o consinit.o errors.o \
	evalinit.o execinit.o hlexinit.o hyaccinit.o lipinit.o print.o symbols.o \
	expr.o gc.o gramaux2.o init.o malloc.o mem.o mathutil.o stack.o \
	modules2.o type2.o typeaux2.o typeinit.o refcount.o \
	profile.o dbginit2.o random.o file.o lip.o table.o dir.o transfer.o \
	bc.o bcaux.o bciaux.o bci0.o bci2.o bcinit.o regexp.o \
	hlex.o hyacc.o OTHEROBJS
LIBHIMMLOBJS = arith.o exec.o lists.o map.o mapinit.o \
	compile2.o compaux2.o compinit.o cons.o consinit.o errors.o \
	evalinit.o execinit.o hlexinit.o hyaccinit.o lipinit.o print.o symbols.o \
	expr.o gc.o gramaux2.o init.o malloc.o mem.o mathutil.o stack.o \
	modules2.o type2.o typeaux2.o typeinit.o refcount.o \
	profile.o dbginit2.o random.o file.o lip.o table.o dir.o transfer.o \
	bc.o bcaux.o bciaux.o bci0.o bci2.o bcinit.o regexp.o \
	hlex.o hyacc.o OTHEROBJS
XOBJS = mlx.o cxaux.o arith.o exec.o lists.o map.o mapinit.o \
	compile2.o compaux2.o compinit2.o cons.o consinit.o errors.o \
	evalinit.o execinit2.o hlexinit2.o hyaccinit2.o lipinit2.o print.o symbols.o \
	expr.o gc2.o gramaux2.o init.o malloc.o mem.o mathutil.o stack.o \
	modules2.o type2.o typeaux2.o typeinit.o refcount.o \
	profile.o dbginit2.o random.o file.o lip.o table.o dir.o transfer2.o \
	bc.o bcaux.o bciaux.o bci0.o bci2.o bcinit.o regexp.o \
	hlex.o hyacc.o OTHEROBJS

.c.o :
	$(CC) $(CFLAGS) $<

.s.o :
	$(AS) $(AFLAGS) $<

TARGET = all

all :   makefile himml Emacs/himml-mode.el himmldep himmlpack himmllnk himmlrun himmlx himmlx.h libhimml.a

clean : makefile
	find . -name '*.o' -exec rm {} \;
	find . -name '*.u' -exec rm {} \;
	find . -name 'core' -exec rm {} \;
	find Emacs -name '*.elc' -exec rm {} \;
	rm -f himml mksys tstrwin proto gmon.out system.h
	rm -f makemaclex makemactab dpxljhak amidate himmldep himmlrun himmlx himmlx.h

cleanall : clean
	find . -name '*.mlx' -exec rm {} \;
	find . -name '*~' -exec rm {} \;
	find . -name HimML.trace -exec rm {} \;
	rm himml.pkg
	rm -f `cat protofiles`

distrib : cleanall
	(cd Doc; make)
	cp fakemake makefile
	/bin/sh makedistrib

himml.pkg : himml Emacs/himml-mode.el himmldep himmlpack himmllnk himmlrun himmlx himmlx.h libhimml.a
	sh mkdist.macosx  
	 
lha : cleanall
	(cd Doc; make)
	cp fakemake makefile
	/bin/sh makelha

install : all
	install -d $(DESTDIR)$(INSTALL_DIR)
	install himml himmlx himmlrun himmldep himmlpack himmllnk $(DESTDIR)$(INSTALL_DIR)
	install -d $(DESTDIR)$(EMACS_DIR)
	install Emacs/himml-mode.el Emacs/himml-site.el $(DESTDIR)$(EMACS_DIR)
	install -d $(DESTDIR)$(INCLUDE_DIR)
	install himmlx.h $(DESTDIR)$(INCLUDE_DIR)
	install -d $(DESTDIR)$(LIB_DIR)
	install libhimml.a $(DESTDIR)$(LIB_DIR)
	install -d $(DESTDIR)$(MAN_DIR)
	install himml.1 himmldep.1 himmllnk.1 himmlpack.1 himmlrun.1 himmlx.1 $(DESTDIR)$(MAN_DIR)

makefile : makefile.tpl config.h
	/bin/sh makemake
	exec make

makedefs : OPTIONS
	@echo >makedefs "#!/bin/sh"
	@echo >>makedefs "CC=\"$(CC)\";export CC"
	@echo >>makedefs "LD=\"$(LD)\";export LD"
	@echo >>makedefs "BISON=\"$(BISON)\";export BISON"
	@echo >>makedefs "FLEX=\"$(FLEX)\";export FLEX"
	@echo >>makedefs "AS=\"$(AS)\";export AS"
	@echo >>makedefs "CFLAGS=\"$(CFLAGS)\";export CFLAGS"
	@echo >>makedefs "AFLAGS=\"$(AFLAGS)\";export AFLAGS"
	@echo >>makedefs "LFLAGS=\"$(LFLAGS)\";export LFLAGS"
	@cat makedef0 >>makedefs

prof : himml
	pixie -o himml.pixie himml
	himml.pixie -path Utils -path Prover -cmd "use\"init.ml\";use\"pack.ml\";quit 0;"
	prof -pixie himml himml.Addrs himml.Counts >himml.prof

config.h : OPTIONS makeconfig.c
	$(LD) -o makeconfig makeconfig.c
	./makeconfig <OPTIONS >config.h
	rm -f makeconfig

himml : $(OBJS) mksys patch makedefs
	-rm -f himml # to avoid ulimit headaches from the linker
	$(LD) -o himml $(OBJS) $(LFLAGS)
	/bin/sh makedefs patch himml

himmlx : $(XOBJS) mksys patch makedefs
	-rm -f himmlx # to avoid ulimit headaches from the linker
	$(LD) -o himmlx $(XOBJS) $(LFLAGS)
	/bin/sh makedefs patch himmlx

himmlrun : $(RUNOBJS) mksys patch makedefs
	-rm -f himmlrun # to avoid ulimit headaches from the linker
	$(LD) -o himmlrun $(RUNOBJS) $(LFLAGS)
	/bin/sh makedefs patch himmlrun

himmlx.a : $(HIMMLXOBJS)
	ar cru himmlx.a $(HIMMLXOBJS)
	ranlib himmlx.a

libhimml.a : $(LIBHIMMLOBJS)
	ar cru libhimml.a $(LIBHIMMLOBJS)
	ranlib libhimml.a

himmldep : dep.c
	$(LD) -o himmldep dep.c

dep.c : dep.l
	$(FLEX) -s -8 -odep.c dep.l

mksys : mksys.c random.src
	$(LD) -o mksys mksys.c -lm

tstrwin.o :

proto :
	(cd Protoize;make;mv proto ..)

system.h random.tbl :	mksys makedefs tstrwin.o mksyscc
	/bin/sh makedefs mksyscc

sarith.h : arith.c proto
	/bin/sh genproto arith.c sarith.h

slists.h : lists.c proto
	/bin/sh genproto lists.c slists.h

smap.h : map.c proto
	/bin/sh genproto map.c smap.h

smapinit.h : mapinit.c proto
	/bin/sh genproto mapinit.c smapinit.h

sevlinit.h : evalinit.c proto
	/bin/sh genproto evalinit.c sevlinit.h

arith.o : $(EVAL) $(EXPR) sarith.h

lists.o : $(EVAL) $(EXPR) $(MEM) slists.h

map.o : $(EVAL) $(EXPR) smap.h

table.o : $(EVAL) $(EXPR) table.h

mapinit.o : $(EVAL) $(EXPR) smapinit.h

evalinit.o : $(EVAL) $(EXPR) $(BYTECODE) sevlinit.h

#sufind.h : ufind.c proto
#	/bin/sh genproto ufind.c sufind.h

#ufind.o : $(EVAL) $(EXPR) $(UFIND) sufind.h

sbc.h : bc.c proto
	/bin/sh genproto bc.c sbc.h

bc.o : $(EVAL) $(EXPR) $(BCAUX) $(MEM) sbc.h

bc2.o : $(EVAL) $(EXPR) $(BCAUX) $(MEM) sbc.h

sbcaux.h : bcaux.c proto
	/bin/sh genproto bcaux.c sbcaux.h

bcaux.o : $(EVAL) $(EXPR) $(BCAUX) $(MEM) sbcaux.h

bcaux2.o : $(EVAL) $(EXPR) $(BCAUX) $(MEM) sbcaux.h

hastag.c labs.c : genlab.c bci.c
	$(LD) -o genlab genlab.c
	./genlab
	rm genlab

bciaux.o : $(MEM) $(EVAL) $(EXPR) bciaux.h

sbci.h : bci.c proto hastag.c labs.c
	/bin/sh genproto bci.c sbci.h

bci0.o : $(EVAL) $(EXPR) $(BYTECODE) rbc.h

bci.o : $(MEM) $(EVAL) $(BYTECODE) $(EXPR) $(TIMING) $(DEBUGGER) $(BCI) sbci.h

bci2.o : bci.c $(MEM) $(EVAL) $(BYTECODE) $(EXPR) $(TIMING) $(DEBUGGER) $(BCI) sbci.h
	$(CC) $(CFLAGS) $< -DHIMMLRUN -o bci2.o

bcinit.o : $(EVAL) $(BYTECODE) $(EXPR)

sexec.h : exec.c proto
	/bin/sh genproto exec.c sexec.h

exec.o : $(MEM) $(EVAL) $(EXPR) $(TIMING) $(TRANSFER) sexec.h

scompile.h : compile.c proto
	/bin/sh genproto compile.c scompile.h

compile.o : $(MEM) $(EVAL) $(ABSSYN) $(GRAM) $(COMPILE) $(TYPE) $(EXPR) $(DEBUGGER) $(REGEXP) scompile.h

compile2.o : $(MEM) $(EVAL) $(ABSSYN) $(GRAM) $(COMPILE) $(TYPE) $(EXPR) $(DEBUGGER) $(REGEXP) scompile.h

scompaux.h : compaux.c proto
	/bin/sh genproto compaux.c scompaux.h

compaux.o :  $(MEM) $(EVAL) $(ABSSYN) $(COMPILE) $(TYPE) $(EXPR) $(DEBUGGER) scompaux.h

compaux2.o :  $(MEM) $(EVAL) $(ABSSYN) $(COMPILE) $(TYPE) $(EXPR) $(DEBUGGER) scompaux.h

sinline.h : inline.c proto
	/bin/sh genproto inline.c sinline.h

inline.o : $(MEM) $(EVAL) $(ABSSYN) $(GRAM) $(COMPILE) $(TYPE) $(EXPR) $(DEBUGGER) sinline.h

scmpinit.h : compinit.c proto
	/bin/sh genproto compinit.c scmpinit.h

compinit.o : compinit.c $(EVAL) $(COMPILE) $(EXPR) scmpinit.h

compinit2.o : compinit.c $(EVAL) $(COMPILE) $(EXPR) scmpinit.h
	$(CC) $(CFLAGS) $< -DHIMMLX -o compinit2.o

scons.h : cons.c proto
	/bin/sh genproto cons.c scons.h

cons.o : $(MEM) $(EVAL) $(EXPR) $(SPECIAL) $(CONS) scons.h

scnsinit.h : consinit.c proto
	/bin/sh genproto consinit.c scnsinit.h

consinit.o : $(EVAL) $(EXPR) $(SPECIAL) $(CONS) scnsinit.h

sdbginit.h : dbginit.c proto
	/bin/sh genproto dbginit.c sdbginit.h

dbginit.o : $(EVAL) $(EXPR) $(DEBUGGER) $(TYPE) $(BCAUX) sdbginit.h

dbginit2.o : $(EVAL) $(EXPR) $(DEBUGGER) $(TYPE) $(BCAUX) sdbginit.h

sdebug.h : debug.c config.h proto
	/bin/sh genproto debug.c sdebug.h

debug.o : $(MEM) $(EVAL) $(EXPR) $(DEBUGGER) $(TYPE) $(COMPILE) $(PRINT) $(BYTECODE) $(BCI) sdebug.h

sprofile.h : profile.c config.h proto
	/bin/sh genproto profile.c sprofile.h

profile.o : $(MEM) $(EVAL) $(EXPR) $(DEBUGGER) $(TYPE) $(COMPILE) $(PRINT) $(BYTECODE) $(BCI) sprofile.h

serrors.h : errors.c proto
	/bin/sh genproto errors.c serrors.h

errors.o : $(EVAL) $(MESSAGE) serrors.h

sprint.h : print.c proto
	/bin/sh genproto print.c sprint.h

print.o :   $(EVAL) $(PRINT) $(TYPE) $(EXPR) sprint.h

ssymbols.h : symbols.c proto
	/bin/sh genproto symbols.c ssymbols.h

symbols.o : $(EVAL) $(EXPR) ssymbols.h

sexcinit.h : execinit.c proto
	/bin/sh genproto execinit.c sexcinit.h

execinit.o : execinit.c $(EVAL) $(COMPILE) $(EXPR) $(EXECINIT) $(TYPE) sexcinit.h
	$(CC) $(CFLAGS) $< -DDATE="\"`date`\n\""

execinit2.o : execinit.c $(EVAL) $(COMPILE) $(EXPR) $(EXECINIT) $(TYPE) sexcinit.h
	$(CC) $(CFLAGS) $< -DHIMMLX -DDATE="\"`date`\n\"" -o execinit2.o

sexpr.h : expr.c proto
	/bin/sh genproto expr.c sexpr.h

expr.o :	$(EVAL) $(EXPR) $(SPECIAL) $(MEM) sexpr.h

sgc.h : gc.c proto
	/bin/sh genproto gc.c sgc.h

gc.o :  $(MEM) $(EVAL) $(TYPE) $(COMPILE) $(GRAM) $(EXPR) $(SPECIAL) $(CONS) $(DEBUGGER) $(TIMING) sgc.h

gc2.o :  gc.c $(MEM) $(EVAL) $(TYPE) $(COMPILE) $(GRAM) $(EXPR) $(SPECIAL) $(CONS) $(DEBUGGER) $(TIMING) sgc.h
	$(CC) $(CFLAGS) $< -DXLATE -o gc2.o

sgramaux.h : gramaux.c proto
	/bin/sh genproto gramaux.c sgramaux.h

gramaux.o : gramaux.c $(MEM) $(EVAL) $(ABSSYN) $(EXPR) $(GRAM) $(COMPILE) $(INPUT) $(TYPE) $(DEBUG) sgramaux.h
	$(CC) $(CFLAGS) $< -DINSTALL_DIR="\"$(INSTALL_DIR)\""

gramaux2.o : gramaux2.c $(MEM) $(EVAL) $(ABSSYN) $(EXPR) $(GRAM) $(COMPILE) $(INPUT) $(TYPE) $(DEBUG) sgramaux.h

sinit.h : init.c proto
	/bin/sh genproto init.c sinit.h

init.o : $(MEM) $(APPLMEM) $(EXECINIT) $(ACTIONS) $(EVAL) $(TIMING) sinit.h

smalloc.h : malloc.c proto
	/bin/sh genproto malloc.c smalloc.h

smem.h : mem.c proto
	/bin/sh genproto mem.c smem.h

malloc.o : $(PORTABLE) $(MEM) smalloc.h

mem.o : $(PORTABLE) $(MEM) smem.h

smthutil.h : mathutil.c proto
	/bin/sh genproto mathutil.c smthutil.h

mathutil.o : $(PORTABLE) smthutil.h

sml.h : ml.c proto
	/bin/sh genproto ml.c sml.h

ml.o :  $(PORTABLE) $(INPUT) $(DEBUGGER) $(EVAL) sml.h

mlrun.o :  $(PORTABLE) $(INPUT) $(DEBUGGER) $(EVAL) $(GRAM) $(INPUT) $(TYPE) $(ABSSYN) $(EXPR) sml.h

mlx.o : mlx.c $(PORTABLE) $(INPUT) $(DEBUGGER) $(EVAL) $(GRAM) $(INPUT) $(TYPE) $(ABSSYN) $(EXPR) sml.h cxaux.h mlstart.inc.c
	$(CC) $(CFLAGS) -DCC="\"$(CC)\"" -DCFLAGS="\"$(STACK_CFLAGS)\"" -DLD="\"$(LD)\"" -DLFLAGS="\"$(LFLAGS)\"" -DLIB_DIR="\"$(LIB_DIR)\"" mlx.c

mlstart.inc.c : himml mlstart.c mkstart.ml
	awk "BEGIN { s=0; };\
	{if (s==2) print; }\
	/\/\*/ { if (s==0) s=1; };\
	/\*\// { if (s==1) s=2; };" mlstart.c |\
	./himml -cmd "use \"mkstart.ml\"; f (); quit 0;" >mlstart.inc.c

smodules.h : modules.c proto
	/bin/sh genproto modules.c smodules.h

modules.o : $(EVAL) $(TYPE) $(EXPR) smodules.h

modules2.o : $(EVAL) $(TYPE) $(EXPR) smodules.h

sstack.h : stack.c proto
	/bin/sh genproto stack.c sstack.h

stack.o : stack.c $(STACK) $(EVAL) $(EXPR) $(MEM) $(DEBUG) sstack.h
	$(CC) $(STACK_CFLAGS) stack.c

strans.h : transfer.c proto
	/bin/sh genproto transfer.c strans.h

transfer.o : $(EVAL) $(EXPR) $(GRAM) $(COMPILE) $(TYPE) $(MEM) $(TRANSFER) $(DEBUGGER) strans.h

transfer2.o : transfer.c $(EVAL) $(EXPR) $(GRAM) $(COMPILE) $(TYPE) $(MEM) $(TRANSFER) $(DEBUGGER) strans.h
	$(CC) $(CFLAGS) $< -DXLATE -o transfer2.o

stype.h : type.c proto
	/bin/sh genproto type.c stype.h

type.o :  $(EVAL) $(ABSSYN) $(GRAM) $(TYPE) $(EXPR) $(MEM) stype.h

type2.o :  $(EVAL) $(ABSSYN) $(GRAM) $(TYPE) $(EXPR) $(MEM) stype.h

stypeaux.h : typeaux.c proto
	/bin/sh genproto typeaux.c stypeaux.h

typeaux.o : $(MEM) $(EVAL) $(ABSSYN) $(TYPE) $(EXPR) stypeaux.h

typeaux2.o : $(MEM) $(EVAL) $(ABSSYN) $(TYPE) $(EXPR) stypeaux.h

stypinit.h : typeinit.c proto
	/bin/sh genproto typeinit.c stypinit.h

typeinit.o : $(EVAL) $(TYPE) $(EXPR) stypinit.h

srefcnt.h : refcount.c config.h proto
	/bin/sh genproto refcount.c srefcnt.h

refcount.o : $(MEM) $(EVAL) $(EXPR) $(SPECIAL) $(CONS) $(COMPILE) $(TYPE) srefcnt.h

sregexp.h : regexp.c config.h proto
	/bin/sh genproto regexp.c sregexp.h

regexp.o : regexp.c $(REGEXP) $(EVAL) $(EXPR) $(TRANSFER) $(MEM) sregexp.h

sgram.h : himml.tab.c proto
	/bin/sh genproto himml.tab.c sgram.h

himml.tab.o : $(EVAL) $(ABSSYN) $(EXPR) $(GRAM) $(TYPE) $(COMPILE) $(INPUT) $(DEBUGGER) sgram.h

slex.h : himml.yy.c proto
	/bin/sh genproto himml.yy.c slex.h

himml.yy.o : $(MEM) $(EVAL) $(GRAM) $(INPUT) $(ABSSYN) $(EXPR) himml.tab.c slex.h

srandom.h : random.c proto
	/bin/sh genproto random.c srandom.h

random.o : $(PORTABLE) random.tbl srandom.h

sfile.h : file.c proto
	/bin/sh genproto file.c sfile.h

file.o : $(PORTABLE) $(MEM) $(TIMING) sfile.h

sdir.h : dir.c proto
	/bin/sh genproto dir.c sdir.h

dir.o : $(MEM) $(TIMING) $(EVAL) sdir.h

shlexinit.h : hlexinit.c proto
	/bin/sh genproto hlexinit.c shlexinit.h

hlexinit.o : hlexinit.c $(EVAL) $(EXPR) $(TYPE) shlexinit.h

hlexinit2.o : hlexinit.c $(EVAL) $(EXPR) $(TYPE) shlexinit.h
	$(CC) $(CFLAGS) $< -DHIMMLX -o hlexinit2.o

shlex.h : hlex.c proto
	/bin/sh genproto hlex.c shlex.h

hlex.o : $(MEM) $(TIMING) $(EVAL) $(EXPR) $(TRANSFER) shlex.h

shyaccinit.h : hyaccinit.c proto
	/bin/sh genproto hyaccinit.c shyaccinit.h

hyaccinit.o : hyaccinit.c $(EVAL) $(EXPR) $(TYPE) shyaccinit.h

hyaccinit2.o : hyaccinit.c $(EVAL) $(EXPR) $(TYPE) shyaccinit.h
	$(CC) $(CFLAGS) $< -DHIMMLX -o hyaccinit2.o

shyacc.h : hyacc.c proto
	/bin/sh genproto hyacc.c shyacc.h

hyacc.o : $(MEM) $(TIMING) $(EVAL) $(EXPR) $(TRANSFER) shyacc.h

lipinit.o : lipinit.c $(EVAL) $(TYPE) $(LIP) $(EXPR)

lipinit2.o : lipinit.c $(EVAL) $(TYPE) $(LIP) $(EXPR)
	$(CC) $(CFLAGS) $< -DHIMMLX -o lipinit2.o

lip.o : $(EVAL) $(LIP) $(TRANSFER) $(EXPR) $(MEM)

messages :
	touch messages # because Sun make thinks it can build it from messages.r

makemactab : makemactab.l system.h # $(BISON)
	$(FLEX) -s -8 -ommt.c makemactab.l
	$(LD) -o makemactab mmt.c
	rm mmt.c

#himml.tab.c himml.tab.h tab.r :	gram.y makemactab # $(BISON)
#	(BISON_SIMPLE=./bison.simple; export BISON_SIMPLE; $(BISON) -dl gram.y)
#	./makemactab <gram.tab.c >himml.tab.c
#	rm gram.tab.c
#	mv gram.tab.h himml.tab.h

makemaclex : makemaclex.l system.h # $(FLEX)
	$(FLEX) -s -8 -omml.c makemaclex.l
	$(LD) -o makemaclex mml.c
	rm mml.c

#himml.yy.c lex.r :  lex.l makemaclex # $(FLEX)
#	$(FLEX) -Sflex.skl -s -L -8 lex.l
#	./makemaclex <lex.yy.c >himml.yy.c
#	rm lex.yy.c

#Emacs/himml-mode.elc : Emacs/himml-mode.el
#	(cd Emacs; emacs -batch --eval "(byte-compile-file \"himml-mode.el\")")

himmlpack: himmlpack.ml himml
	./himml -c himmlpack.ml
	chmod a+x himmlpack.mlx
	mv himmlpack.mlx himmlpack

himmllnk:

himmlx.h: $(EVAL) $(GRAM) $(INPUT) $(TYPE) $(ABSSYN) $(TRANSFER) himmlx1.h
	sh ./mkhimmlx.sh >himmlx.h

cxaux.o : $(EVAL) $(EXPR) $(CONS) $(BYTECODE) cxaux.h

