/* Prototypes for printing functions.
   Copyright (C) 1992-2000 Jean Goubault-Larrecq and Bull S.A.
   Copyright (C) 2000-2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

IMPORT void realPrint P((IN CONST REAL *x,
			 IN printFunc doprint,
			 INOUT char *printdata));
IMPORT void do_printfile P((IN CONST CHAR *text,IN COUNTER len,INOUT char *stream)); /* actually, stream is an hFILE * */

IMPORT void valPrint P((IN CONST ExprPtr val,
			IN CONST ExprPtr type,
			IN printFunc doprint,
			INOUT char *printdata,
			IN COUNTER pri));
IMPORT void endPretty P((IN printFunc doprint,INOUT char *printdata));
IMPORT Boolean valPretty P((IN CONST ExprPtr val,
			    IN CONST ExprPtr type,
			    IN printFunc doprint,
			    INOUT char *printdata,
			    IN COUNTER pri,
			    IN COUNTER lmargin,
			    IN COUNTER rmargin));
IMPORT void valPrintNoType P((IN CONST ExprPtr val,
			      IN printFunc doprint,
			      INOUT char *printdata,
			      IN COUNTER pri));
IMPORT void valsPrint P((IN CONST ExprPtr assum,
			 IN CONST printFunc doprint,
			 INOUT VOIDPTR printdata));
IMPORT void TypePrint P((IN CONST ExprPtr type,
			 IN printFunc doprint,
			 INOUT char *printdata,
			 IN CONST ExprPtr state));
IMPORT Boolean TypePretty P((IN CONST ExprPtr type,
			     IN printFunc doprint,
			     INOUT char *printdata,
			     IN CONST ExprPtr state,
			     IN COUNTER lmargin,
			     IN COUNTER rmargin));
IMPORT Boolean typeEnvPrint P((IN CONST ExprPtr assum,
			       IN CONST printFunc doprint,
			       INOUT VOIDPTR printdata,
			       IN CONST ExprPtr state));
IMPORT void dynPrint P((IN CONST ExprPtr val,
			IN printFunc doprint,INOUT char *printdata,
			IN COUNTER pri));
IMPORT Boolean dynPretty P((IN CONST ExprPtr val,
			    IN printFunc doprint,INOUT char *printdata,
			    IN COUNTER lmargin,IN COUNTER rmargin));

EXTERN ExprPtr rightMarginRef;

IMPORT ExprPtr getValueByName P((IN CONST ExprPtr name,OUT Boolean *foundp,
				 IN CONST ExprPtr env));
IMPORT ExprPtr getTypeInExn P((IN CONST ExprPtr exc));
