/* Static structures for bc.c.
   Copyright (C) 1995-2000 Jean Goubault-Larrecq and Bull S.A.
   Copyright (C) 2000-2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

typedef void (*bindCompFun) P((IN bcFile *f,
			       IN CONST compEnv *env,
			       IN CONST ExprPtr bindings,
			       INOUT ExprPtr errp));

typedef MapPtr (*freeVarsFun) P((IN CONST ExprPtr e, INOUT compEnv *env));
typedef Boolean (*needEnvFun) P((IN CONST ExprPtr e, INOUT compEnv *env));

struct freevars {
  ExprPtr code;
  compEnv *env;
};

struct needenv {
  ExprPtr code;
  compEnv *env;
  Boolean res;
};

struct compilebinding {
  bcFile *f;
  compEnv *env;
  ExprPtr binding;
  ExprPtr errp;
};

struct dumpletstores {
  bcFile *f;
  INT envlevel;
};

struct flushdbgnames {
  bcFile *f;
  compEnv *env;
};

struct compilevectormatch {
  bcFile *f;
  compEnv *env;
  ExprPtr pat;
  COUNTER idx;
  COUNTER level;
  ExprPtr errp;
  ExprPtr choicelist;
};

struct constantpattern {
  ExprPtr pat;
  ExprPtr memoref;
  Boolean constp;
};

struct compilepattern {
  bcFile *f;
  compEnv *env;
  ExprPtr pat;
  ExprPtr errp;
  ExprPtr choicelist;
  Boolean notagcheck;
};

struct compilepolyfun1 {
  bcFile *f;
  compEnv *env;
  ExprPtr func;
  compileFunc compile;
  COUNTER push;
  ExprPtr wrongp;
  ExprPtr arglist;
  COUNTER nargs;
};

struct compiletest {
  bcFile *f;
  compEnv *env;
  ExprPtr e;
  ExprPtr wrongp;
};

struct compilestmt {
  bcFile *f;
  compEnv *env;
  ExprPtr e;
};

struct sweepinfo {
  COUNTER listref;
  COUNTER auxref;
};

struct compilerecmapaddpattern {
  bcFile *f;
  compEnv *env;
  ExprPtr pat;
  COUNTER level;
  ExprPtr errp;
  ExprPtr choicelist;
};

struct compilemapaddpattern {
  bcFile *f;
  compEnv *env;
  ExprPtr pat;
  ExprPtr nomatchp;
  ExprPtr choicelist;
  ExprPtr emptyp;
};

struct compilesimpleofk {
  bcFile *f;
  compEnv *env;
  struct compilesimpleof *data;
  ExprPtr failp;
  COUNTER errlevel;
  COUNTER errmaplevel;
  ExprPtr errp;
  COUNTER reslevel;
};

struct compiledomainssimplek {
  bcFile *f;
  compEnv *env;
  ExprPtr domains;
  ExprPtr locals;
};

struct bceval {
  byteCodeChunk *bc;
  ExprPtr arg[1]; /* env, arg1, ..., argn */
};
