/* Static structures for typeaux.c.
   Copyright (C) 1992-2000 Jean Goubault-Larrecq and Bull S.A.
   Copyright (C) 2000-2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

struct addtopfx {
  ExprPtr assum,state;
};

struct addtopfx1 {
  ExprPtr type;
  ExprPtr assum;
  ExprPtr state;
};

struct newtypeinst {
  MapPtr new;
  ExprPtr assum,state;
  ExprPtr fIrename;
#if IMPERATIVE_TYPES!=EFFECT_TYVAR
  Boolean noimpp;
#endif
};

struct newtypeinstk {
  ExprPtr type;
  ExprPtr assum,state;
#if IMPERATIVE_TYPES!=EFFECT_TYVAR
  Boolean noimpp;
#endif
  MapPtr fIrename;
};

struct eqtypep {
  ExprPtr state;
  ExprPtr exit;
  Boolean eqp;
};

struct eqtypepk {
  ExprPtr type;
  ExprPtr state;
  Boolean eqp;
};

struct imptypep {
  INT strength;
  ExprPtr state;
};

struct imptypepk {
  ExprPtr type;
  ExprPtr state;
#if IMPERATIVE_TYPES==STD_ML_NJ_TYVAR
  INT strength;
#endif
  Boolean res;
};

struct typemul {
  MapPtr type1,type2;
};

struct occursp {
  ExprPtr typevar;
  ExprPtr state;
};

struct occurspk {
  ExprPtr typevar;
  ExprPtr type;
  ExprPtr state;
  Boolean res;
};

struct typeattr {
  int new_flags;
#if IMPERATIVE_TYPES==STD_ML_NJ_TYVAR
  INT strength,maxstrength;
#endif
  ExprPtr assum;
  ExprPtr state;
  ExprPtr eqtdg;
};

struct typeattrk {
  int new_flags;
  ExprPtr eqtdg;
#if IMPERATIVE_TYPES==STD_ML_NJ_TYVAR
  INT strength,maxstrength;
#endif
  ExprPtr type;
  ExprPtr assum;
  ExprPtr state;
  Boolean res;
};

struct instnumtype {
  ExprPtr state;
  MapPtr subst;
  Boolean fine;
};

struct instnumtypek {
  MapPtr map;
  MapPtr subst;
  ExprPtr state;
  Boolean fine;
};

struct unify_num {
  MapPtr varmap,quanmap;
  ExprPtr assum,state;
  MapPtr map1,map2;
  ExprPtr strongest;
  Boolean higherp;
};

struct find_flexappl_num {
  ExprPtr assum;
  ExprPtr state;
  ExprPtr realflex;
  ExprPtr altflex;
  Boolean altflexp;
};

struct unify_map {
  MapPtr type1,type2;
  ExprPtr assum,state;
  Boolean higherp;
};

struct unify1 {
  ExprPtr type1,type2;
  ExprPtr assum;
  ExprPtr state;
  Boolean higherp;
  Boolean res;
};

struct cyclicfx {
  ExprPtr assum,state;
};

struct weaken {
  ExprPtr assum,state;
  INT delta;
  MapPtr *donep;
};

struct weakenk {
  ExprPtr type;
  ExprPtr assum;
  ExprPtr state;
  INT delta;
  MapPtr done;
};

struct mergerecordtypes {
  TZone *zone;
  MapPtr rec2;
  ExprPtr assum;
  ExprPtr state;
};

struct typesubst {
  MapPtr new;
  MapPtr subst;
  ExprPtr assum;
  ExprPtr state;
  TZone *zone;
};

struct typesubstk {
  TZone zone;
  ExprPtr type;
  MapPtr subst;
  ExprPtr assum;
  ExprPtr state;
};

struct obsfx {
  MapPtr vars;
  ExprPtr state;
};

struct typerenamemap {
  ExprPtr info;
  ExprPtr assum;
  ExprPtr state;
};

struct typerenamek {
  ExprPtr type;
  ExprPtr info;
  ExprPtr assum;
  ExprPtr state;
};

struct pack_check {
  ExprPtr assum;
  ExprPtr state;
  ExprPtr memoref;
};

struct geteq {
  ExprPtr state;
  ExprPtr tyfcns;
  MapPtr sureeq;
  Boolean noeq;
};

struct fulleq {
  MapPtr simpleeqs;
  MapPtr subst;
};

struct checkeqcond {
  MapPtr eqs1,eqs2;
  TZone *zone;
  ExprPtr state;
};

struct checkexplicits {
  TZone *zone;
  ExprPtr assum;
  ExprPtr state;
  MapPtr values;
  ExprPtr wrong;
};

struct tyvars {
  ExprPtr assum,state;
  SHORT flags;
#if IMPERATIVE_TYPES==STD_ML_NJ_TYVAR
  INT strength;
#endif
  ExprPtr memoref;
};

struct tyvarsk {
  ExprPtr type;
  ExprPtr assum;
  ExprPtr state;
  SHORT flags;
#if IMPERATIVE_TYPES==STD_ML_NJ_TYVAR
  INT strength;
#endif
  ExprPtr memoref;
};

struct unquant {
  ExprPtr assum,state;
  ExprPtr memoref;
};

struct setstrengths {
  ExprPtr state;
  ExprPtr strength;
};

struct checkstrengths {
  TZone *zone;
  ExprPtr state;
};

struct instscale {
  ExprPtr coeff;
  MapPtr var;
  ExprPtr state;
};

struct unifyscale {
  ExprPtr constmap,varmap;
  MapPtr map1,map2;
  ExprPtr assum;
};
