/* Prototypes for stack-related functions.
   Copyright (C) 1992-2000 Jean Goubault-Larrecq and Bull S.A.
   Copyright (C) 2000-2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

typedef CONST void (*mlAction) P((INOUT char *data));

IMPORT void doML P((IN mlAction fun,INOUT char *data));
typedef NORETURN void (*loweredStackAction) P((char *data));

IMPORT NORETURN void InitStack P((loweredStackAction fun,char *data)) _NORETURN;
IMPORT NORETURN void EndStack P((int n)) _NORETURN;

IMPORT void setHandlerStack P((IN CONST excHandler *stack));
IMPORT void resetHandlerStack P((void));

IMPORT void stackChunkFree P((INOUT StackChunk *chunk));

IMPORT void lockThread P((IN CONST stackMark *mark));
IMPORT void unlockThread P((IN CONST stackMark *mark));
