/* Naive bytecode to C compiler.
   Copyright (C) 2004 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include "eval.h"
#if TRANSLATOR
#include "expr.h"
#include "refcount.h"
#include "mem.h"
#include "bc.h"
#include "errproto.h"
#ifdef HAS_STRING_H
#include <string.h>
#else
#include <strings.h>
#endif
#include "iter.h"
#include "rbc.h"
#ifdef HAS_PROTOTYPES
#include "sbc.h"
#endif

#define __SEG__ TRANS

/* Each function f (byteCodeChunk) is translated to:
   struct Expression *f_consts[nConsts];
   ExprPtr f_code (IN CONST ExprPtr e, IN CONST ExprPtr env);
*/

PRIVATE void transOpcodes (f, prefix, instr, endinstr, stacklevel)
OUT hFILE *f;
IN CONST CHAR *prefix;
IN CONST OPCODE *instr;
IN CONST OPCODE *endinstr;
IN COUNTER stacklevel;
{
  OPCODE *pc;
  OPCODE op;

  for (pc=instr; pc<endinstr; )
    {
      hfprintf (f, "lab%d: ", pc-instr);
      switch (op = *pc++)
	{
	case BC_CGLOBAL:
	  /* No need to synchronize _x.n, since gc cannot be triggered here. */
	  hfprintf (f, "_x.p[%d] = CGlobals[%d];\n", stacklevel++, (COUNTER)*pc++);
	  break;
	case BC_CONST:
	  /* No need to synchronize _x.n, since gc cannot be triggered here. */
	  hfprintf (f, "_x.p[%d] = %s_consts[%d];\n", stacklevel++, prefix, (COUNTER)*pc++);
	  break;
	case BC_CLOSURE:
	  hfprintf (f, "_x.n = %d; _x.p[%d] = " /*!!!*/
	}
    }
}

